// ROOT Libraries
#include "TH1D.h"
// Standard Libraries
#include <vector>
// Other
#include "samples.h"

#ifndef HISTOGRAMS1D_H
#define HISTOGRAMS1D_H

using std::vector;

class Histograms1D
{

	public:
		Histograms1D(const char * fn);
		Histograms1D(const Histograms1D & histos);
		~Histograms1D();
		void readHistograms(const char * fileName);
		void fillHistograms(const Samples::sample & sample);
		void scaleHistograms(double sf);
		unsigned getNhistos() {
			return histos1D.size();
		}
		TH1D * getHisto(unsigned n);
		string getName() {
			return name_;
		}
	private:
		vector<TH1D *> histos1D;
		string name_;


};

class HistoFiller {
	public:
		HistoFiller(string name, const event & ev);
		~HistoFiller() {};
		double getValue();
	private:
		enum TYPE { UNSIGNED, INT, DOUBLE };
		TYPE type_;
		const unsigned * valueU_;
		const int * valueI_;
		const double * valueD_;
		
};

#endif // HISTOGRAMS1D_H
